/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GENERATOR_H
#define GENERATOR_H

#include "bitboard.h"

/**
 * \file generator.h
 * ???
 */

#define GENERATOR_MOVES 100

#define rank1 255ull

#define rank2 65280ull

#define rank3 16711680ull

#define rank4 4278190080ull

#define rank5 1095216660480ull

#define rank6 280375465082880ull

#define rank7 71776119061217280ull

#define rank8 18374686479671623680ull

#define fileA 72340172838076673ull
#define fileB 144680345676153346ull
#define fileC 289360691352306692ull
#define fileD 578721382704613384ull
#define fileE 1157442765409226768ull
#define fileF 2314885530818453536ull
#define fileG 4629771061636907072ull
#define fileH 9259542123273814144ull
#define notFileA 18374403900871474942ull
#define notFileH 9187201950435737471ull
#define notFileAB 18229723555195321596ull
#define notFileGH 4557430888798830399ull

#define shiftDown(b)      ((b)>>8)
#define shift2Down(b)     ((b)>>16)
#define shiftUp(b)        ((b)<<8)
#define shift2Up(b)       ((b)<<16)
#define shiftRight(b)     (((b)<<1)&notFileA)
#define shift2Right(b)    (((b)<<2)&notFileAB)
#define shiftLeft(b)      (((b)>>1)&notFileH)
#define shift2Left(b)     (((b)>>2)&notFileGH)
#define shiftUpLeft(b)    (((b)<<7)&notFileH)
#define shiftUpRight(b)   (((b)<<9)&notFileA)
#define shiftDownLeft(b)  (((b)>>9)&notFileH)
#define shiftDownRight(b) (((b)>>7)&notFileA)

extern UINT64 attackPawn[2][64];

extern UINT64 attackKnight[64];

extern UINT64 attackKing[64];

/**
 * \fn void initGenerator();
 * ???
 */
void initGenerator();

/**
 * \fn int generateMoves(struct bitboard* position, int moves[]);
 * ???
 * @param position ???
 * @param moves ???
 * @return indeks ???
 */
int generateMoves(struct bitboard* position, int moves[]);

/**
 * \fn int generateStaticMoves(struct bitboard* position, int moves[]);
 * ???
 * @param position ???
 * @param moves ???
 * @return indeks ???
 */
int generateStaticMoves(struct bitboard* position, int moves[],int history[64][64]);

/**
 * \fn int generateDynamicMoves(struct bitboard* position, int moves[]);
 * ???
 * @param position ???
 * @param moves ???
 * @return indeks ???
 */
int generateDynamicMoves(struct bitboard* position, int moves[]);

/**
 * \fn inline UINT64 attackRook(struct bitboard* position, int square);
 * ???
 * @param position ???
 * @param square ???
 * @return ???
 */
inline UINT64 attackRook(struct bitboard* position, int square);

/**
 * \fn inline UINT64 attackBishop(struct bitboard* position, int square);
 * ???
 * @param position ???
 * @param square ???
 * @return ???
 */
inline UINT64 attackBishop(struct bitboard* position, int square);

#endif
