/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <string.h>
 
#include "move.h"
#include "square.h"

void moveSPrint(char smove[], int move){
	char square[3];
	smove[0] = '\0';
	switch(moveGetType(move)){
		case NORMAL_MOVE:
		case CAPTURE_MOVE:
		case (WHITE_CASTLING_KING_SIDE & TYPE_STATUS):
		case (WHITE_CASTLING_QUEEN_SIDE & TYPE_STATUS):
		case (BLACK_CASTLING_KING_SIDE & TYPE_STATUS):
		case (BLACK_CASTLING_QUEEN_SIDE & TYPE_STATUS):
		case ENPASSANT_MOVE:{
			 squareSPrint(square,moveGetFrom(move));
			 strcat(smove,square);
			 squareSPrint(square,moveGetTo(move));
			 strcat(smove,square);
			 return;
		}
		case PROMOTION_QUEEN:{
			 squareSPrint(square,moveGetFrom(move));
			 strcat(smove,square);
			 squareSPrint(square,moveGetTo(move));
			 strcat(smove,square);
			 strcat(smove,"q");
			 return;
		}
		case PROMOTION_ROOK:{
			 squareSPrint(square,moveGetFrom(move));
			 strcat(smove,square);
			 squareSPrint(square,moveGetTo(move));
			 strcat(smove,square);
			 strcat(smove,"r");
			 return;
		}
		case PROMOTION_BISHOP:{
			 squareSPrint(square,moveGetFrom(move));
			 strcat(smove,square);
			 squareSPrint(square,moveGetTo(move));
			 strcat(smove,square);
			 strcat(smove,"b");
			 return;
		}
		case PROMOTION_KNIGHT:{
			 squareSPrint(square,moveGetFrom(move));
			 strcat(smove,square);
			 squareSPrint(square,moveGetTo(move));
			 strcat(smove,square);
			 strcat(smove,"n");
			 return;
		}
		default:{
			strcat(smove,"xxxx");
			break;
		}
	}
}

void movePrint(int move){
	char smove[6];
	moveSPrint(smove,move);
	printf("%s\n",smove);
}

void moveTypeSPrint(char smove[], int move){
	moveSPrint(smove,move);
	switch(moveGetType(move)){
		case NORMAL_MOVE:{ strcat(smove," -> normal");break;}
		case CAPTURE_MOVE:{ strcat(smove," -> capture");break;}
		case ENPASSANT_MOVE:{strcat(smove," -> en passant");break;}
		case WHITE_CASTLING_KING_SIDE:{strcat(smove," -> white castling king side");break;}
		case WHITE_CASTLING_QUEEN_SIDE:{strcat(smove," -> white castling queen side");break;}
		case BLACK_CASTLING_KING_SIDE:{strcat(smove," -> black castling king side");break;}
		case BLACK_CASTLING_QUEEN_SIDE:{strcat(smove," -> black castling queen side");break;}
		case PROMOTION_QUEEN:{strcat(smove," -> promotion queen");break;}
		case PROMOTION_ROOK:{strcat(smove," -> promotion rook");break;}
		case PROMOTION_BISHOP:{strcat(smove," -> promotion bishop");break;}
		case PROMOTION_KNIGHT:{strcat(smove," -> promotion knight");break;}
	}
}

void moveTypePrint(int move){
	char smove[50];
	moveTypeSPrint(smove,move);
	printf("%s\n",smove);
}

void printMoves(int moves[]){
	int i=0;
	char smove[6];
	while(moves[i] != 0){
		moveSPrint(smove,moves[i]);
		printf("%d. %s\n",++i,smove);
	}
	printf("\n");
}
