/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi�                                 *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>

#include "openingbook.h"
#include "generator.h"
#include "move.h"

int booksize;
UINT64 *bookarray = 0;

void bookCreate(int size){
	booksize = size;
	bookarray = (UINT64 *)calloc(sizeof(UINT64),booksize);
}

void bookPut(int index, UINT64 key){
	bookarray[index] = key;
}

int bookSearchKey(UINT64 target){
	int high = booksize, low = -1, probe;
	while (high - low > 1){
		probe = (high + low) / 2;
		if (bookarray[probe] < target) high = probe;
		else low = probe;
	}
	if (low == -1 || bookarray[low] != target) return -1;
	else return low;
}

int bookSearch(struct bitboard* position){
	if(bookarray == 0) return 0;
	int index=0, moves[GENERATOR_MOVES], oindex=0, omoves[GENERATOR_MOVES];
	generateMoves(position,moves);
	while(1){
		if(!makeNextMove(position,moves,&index)) break;
		if(bookSearchKey(position->key) != -1){
			omoves[oindex] = unmakeMove(position);
			oindex++;
		}
		else unmakeMove(position);
	}
	if(oindex == 0) return 0;
	else return omoves[(int)(oindex*(rand()/(RAND_MAX+1.0)))];
}

void bookDestroy(){
	if(bookarray != 0) free(bookarray);
}
