/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "piece.h"

const char pieceChar[14] = {
	'X','x',
	'P','p',
	'N','n',
	'B','b',
	'R','r',
	'Q','q',
	'K','k'
};

int pieceValue[14] = {
	KING_VALUE,KING_VALUE,
	PAWN_VALUE, PAWN_VALUE,
	KNIGHT_VALUE, KNIGHT_VALUE,
	BISHOP_VALUE, BISHOP_VALUE,
	ROOK_VALUE, ROOK_VALUE,
	QUEEN_VALUE, QUEEN_VALUE,
	KING_VALUE, KING_VALUE
};

int charToPiece(char piece){
	switch(piece){
		case 'P': return WHITE_PAWN;
		case 'N': return WHITE_KNIGHT;
		case 'B': return WHITE_BISHOP;
		case 'R': return WHITE_ROOK;
		case 'Q': return WHITE_QUEEN;
		case 'K': return WHITE_KING;
		case 'p': return BLACK_PAWN;
		case 'n': return BLACK_KNIGHT;
		case 'b': return BLACK_BISHOP;
		case 'r': return BLACK_ROOK;
		case 'q': return BLACK_QUEEN;
		case 'k': return BLACK_KING;
		default: return EMPTY;
	}
}
