/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "sort.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

inline int deli(int moves[],int values[], int levaMeja, int desnaMeja){
	int delilniIndex = levaMeja;
	int tmp = (levaMeja+desnaMeja)>>1;
	int delilniElement1 = moves[tmp], delilniElement2 = values[tmp];
	moves[tmp] = moves[levaMeja];
	moves[levaMeja] = delilniElement1;
	values[tmp] = values[levaMeja];
	values[levaMeja] = delilniElement2;	
	levaMeja++;

	while(1){
		while(values[levaMeja] > delilniElement2 && levaMeja < desnaMeja)
			levaMeja ++;
		while(values[desnaMeja] < delilniElement2 && desnaMeja > levaMeja)
			desnaMeja --;
		if(levaMeja < desnaMeja){
			tmp = values[levaMeja];
			values[levaMeja] = values[desnaMeja];
			values[desnaMeja] = tmp;			
			tmp = moves[levaMeja];
				moves[levaMeja++] = moves[desnaMeja];
			moves[desnaMeja--] = tmp;
		}
		else break;
	}
	if(values[levaMeja] < delilniElement2) levaMeja--;
	values[delilniIndex] = values[levaMeja];
	values[levaMeja] = delilniElement2;	
	moves[delilniIndex] = moves[levaMeja];
	moves[levaMeja] = delilniElement1;
	return levaMeja;
}

inline int deli64(UINT64 values[], int levaMeja, int desnaMeja){
	int delilniIndex = levaMeja;
	UINT64 tmp = (levaMeja+desnaMeja)>>1;
	UINT64 delilniElement = values[tmp];
	values[tmp] = values[levaMeja];
	values[levaMeja] = delilniElement;	
	levaMeja++;

	while(1){
		while(values[levaMeja] > delilniElement && levaMeja < desnaMeja)
			levaMeja ++;
		while(values[desnaMeja] < delilniElement && desnaMeja > levaMeja)
			desnaMeja --;
		if(levaMeja < desnaMeja){
			tmp = values[levaMeja];
			values[levaMeja++] = values[desnaMeja];
			values[desnaMeja--] = tmp;			
		}
		else break;
	}
	if(values[levaMeja] < delilniElement) levaMeja--;
	values[delilniIndex] = values[levaMeja];
	values[levaMeja] = delilniElement;	
	return levaMeja;
}

void sort(int moves[],int values[],int levaMeja, int desnaMeja){
		if(levaMeja < desnaMeja){
			int sredina = deli(moves,values,levaMeja,desnaMeja);
			sort(moves,values,levaMeja,sredina-1);
			sort(moves,values,sredina+1,desnaMeja);
		}
}

void sort64(UINT64 values[],int levaMeja, int desnaMeja){
	if(levaMeja < desnaMeja){
		int sredina = deli64(values,levaMeja,desnaMeja);
		sort64(values,levaMeja,sredina-1);
		sort64(values,sredina+1,desnaMeja);
	}
}
