/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "square.h"
#include "glib.h"

void squareSPrint(char buffer[], int square){
	buffer[0] = ((char)(97+square%8));
	buffer[1] = ((char)((square/8)+49));
	buffer[2] = '\0';
}

int squareToInt(char buffer[]){
	int f=-1, r=-1;
	switch (buffer[0]){
		case 'a':{f=0; break;}
		case 'b':{f=1; break;}
		case 'c':{f=2; break;}
		case 'd':{f=3; break;}
		case 'e':{f=4; break;}
		case 'f':{f=5; break;}
		case 'g':{f=6; break;}
		case 'h':{f=7; break;}
	};
	switch (buffer[1]){
		case '1':{r=0; break;}
		case '2':{r=1; break;}
		case '3':{r=2; break;}
		case '4':{r=3; break;}
		case '5':{r=4; break;}
		case '6':{r=5; break;}
		case '7':{r=6; break;}
		case '8':{r=7; break;}
	};
	return (r*8)+f;
}

const int rotateL90[64] = {
	h1,h2,h3,h4,h5,h6,h7,h8,
	g1,g2,g3,g4,g5,g6,g7,g8,
	f1,f2,f3,f4,f5,f6,f7,f8,
	e1,e2,e3,e4,e5,e6,e7,e8,
	d1,d2,d3,d4,d5,d6,d7,d8,
	c1,c2,c3,c4,c5,c6,c7,c8,
	b1,b2,b3,b4,b5,b6,b7,b8,
	a1,a2,a3,a4,a5,a6,a7,a8,
};

const int rotateR45[64] = {
	a1,b8,c7,d6,e5,f4,g3,h2,
	a2,b1,c8,d7,e6,f5,g4,h3,
	a3,b2,c1,d8,e7,f6,g5,h4,
	a4,b3,c2,d1,e8,f7,g6,h5,
	a5,b4,c3,d2,e1,f8,g7,h6,
	a6,b5,c4,d3,e2,f1,g8,h7,
	a7,b6,c5,d4,e3,f2,g1,h8,
	a8,b7,c6,d5,e4,f3,g2,h1 
};

const int rotateL45[64] = {
	a2,b3,c4,d5,e6,f7,g8,h1,
	a3,b4,c5,d6,e7,f8,g1,h2,
	a4,b5,c6,d7,e8,f1,g2,h3,
	a5,b6,c7,d8,e1,f2,g3,h4,
	a6,b7,c8,d1,e2,f3,g4,h5,
	a7,b8,c1,d2,e3,f4,g5,h6,
	a8,b1,c2,d3,e4,f5,g6,h7,
	a1,b2,c3,d4,e5,f6,g7,h8 
};

int distance(int index1, int index2){
	int distance1 = ABS(file(index1) - file(index2));
	int distance2 = ABS(rank(index1) - rank(index2));
	return MAX(distance1,distance2);
}

int cornerDistance(int index){
	int f = file(index); // stolpci 0 - 7
	int r = rank(index); // vrstice 0 - 7
	if(f > 4) f = 7 - f;
	if(r > 4) r = 7 - r;
	return MAX(f,r);
}

const UINT64 bitboardFile[8] = { 
	72340172838076673ull , 
	144680345676153346ull,
	289360691352306692ull,
	578721382704613384ull,
	1157442765409226768ull,
	2314885530818453536ull,
	4629771061636907072ull,
	9259542123273814144ull };
