/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include <glib.h>
#include <unistd.h>

#include "search.h"
#include "timer.h"

GCond* condTimer;
GMutex* mutexTimer;
GThread* timerThread = 0;
GTimeVal timerTime;


void initTimer(){
	condTimer = g_cond_new();
	mutexTimer = g_mutex_new();
}

void destroyTimer(){
	if(timerThread != 0){
		g_cond_free(condTimer);
		g_mutex_free(mutexTimer);
	}
}

gpointer runTimerFunction(gpointer data){
	g_get_current_time(&timerTime);
	g_time_val_add (&timerTime,(unsigned long)data);
	g_mutex_lock(mutexTimer);
	g_cond_timed_wait(condTimer,mutexTimer,&timerTime);
	g_mutex_unlock(mutexTimer);
	stopSearchSignal();
	return 0;
}

void stratTimer(unsigned int atimeusec){
	timerThread = g_thread_create(runTimerFunction,(gpointer)atimeusec,1,0);
}

void stopTimer(){
	if(timerThread != 0){
		g_cond_signal(condTimer);
		g_thread_join(timerThread);
		timerThread = 0;
	}
}
