/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TRANSPOSITION_TABLE_H
#define TRANSPOSITION_TABLE_H

#include "asm.h"
#include "bitboard.h"

#define EXACT 0

#define ALPHA 1

#define BETA 2

#define FAIL 3

#define MAX_PV 10

struct TranspositionTable{
	UINT64 key;

	int depth;

	int flag;

	int evaluate;

	int move;
};

void ttCreate(unsigned int kSize);

void ttDestroy();

struct TranspositionTable* ttFind(UINT64 key);

void ttRecord(UINT64 key,int depth, int evaluate, int flag, int move);

void ttPrincipalVariant(struct bitboard* position, int ttPV[]);

int ttUsage();

void ttReset();

int ttDepth(UINT64 key);

#endif
