/***************************************************************************
 *   Copyright (C) 2005 by Borko Bokovi                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef UCI_H
#define UCI_H

#include <sys/time.h>
#include "glib.h"
#include "asm.h"

struct uciinfo{
	int depth;

	UINT64 nodes;

	float time;

	int hash;

	int bm;

	float bmTime;
};

void uciRun(char book[]);

void uciWriteInfo(int eval, short depth, unsigned int nodes, GTimeVal time, int pv[], int hash);

void uciWriteBestMove(int move);

void uciNextToken(char line[], char token[]);

struct uciinfo* uciLastInfo();

void uciSetStream(FILE* stream);

void uciIdentity();

void uciIsReady();

void uciInit();
#endif
